/**
 * ------------------------------------------------------------------------
 * JA Magz Template
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

 Magz = window.Magz || {};

 (function($){

 	// overwrite default tooltip/popover behavior (same as Joomla 3.1.5) - This should be done in T3 Framework
	$.fn.tooltip.Constructor.DEFAULTS && ($.fn.tooltip.Constructor.DEFAULTS.html = true);
	$.fn.popover.Constructor.DEFAULTS && ($.fn.popover.Constructor.DEFAULTS.html = true);
	$.fn.tooltip.defaults && ($.fn.tooltip.defaults.html = true);
	$.fn.popover.defaults && ($.fn.popover.defaults.html = true);

	//Magz
	$.extend(Magz, {

		support: (function(){

			var docStyle = document.documentElement.style,
			dummyStyle = document.createElement('div').style,
			undef,

			vendor = (function () {
				var vendors = 't,webkitT,MozT,msT,OT'.split(','),
				t,
				i = 0,
				l = vendors.length;

				for ( ; i < l; i++ ) {
					t = vendors[i] + 'ransform';
					if ( t in dummyStyle ) {
						return vendors[i].substr(0, vendors[i].length - 1);
					}
				}

				return false;
			})(),

			cssVendor = vendor ? '-' + vendor.toLowerCase() + '-' : '',

			prefixStyle = function (style) {
				if ( vendor === '' ) return style;

				style = style.charAt(0).toUpperCase() + style.substr(1);
				return vendor + style;
			},

			result = {
				vendor: vendor,
				cssVendor: cssVendor,

					// Style properties
					transform: prefixStyle('transform'),
					transformOrigin: prefixStyle('transformOrigin'),
					
					transition: prefixStyle('transition'),
					transitionProperty: prefixStyle('transitionProperty'),
					transitionDuration: prefixStyle('transitionDuration'),
					transitionTimingFunction: prefixStyle('transitionTimingFunction'),
					transitionDelay: prefixStyle('transitionDelay'),
					
					perspective: prefixStyle('perspective')
				};

				if (dummyStyle[result.perspective] !== undef) {
					result.has3d = true;
					result.has2d = true;
				} else if (dummyStyle[result.transform] !== undef) {
					result.has2d = true;
				}

				result.translateZ = result.has3d ? ' translateZ(0)' : '';

				helperElem = null;

				return result;
			})()
		})
})(jQuery);

(function($){
	$.fn.equalboxes = function(){
		var maxheight = 0,
			rowheight = 0,
			rowstart = 0,
			height = 0,
			boxes = [],
			top = 0,
			jel = null;

		//all equalheight (item will not align like a mess)
		this.each(function(){
			jel = $(this);
			height = jel.css({'height': '', 'min-height': ''}).removeClass('eq-first').height();

			if(height > maxheight){
				maxheight = height;
			}

			jel.data('orgHeight', height);

		}).css('min-height', maxheight);

		//per row equal-height
		this.each(function() {
			jel = $(this);
			height = jel.data('orgHeight');
			top = jel.position().top;

			if (rowstart != top) {
				boxes.length && $(boxes).css('min-height', rowheight + 1).eq(0).addClass('eq-first');

				// set the variables for the new row
				boxes.length = 0;
				rowstart = jel.position().top;
				rowheight = height;
				boxes.push(this);

			} else {
				boxes.push(this);
				if(height > rowheight){
					rowheight = height;
				}
			}
		});

		boxes.length && $(boxes).css('min-height', rowheight + 1).eq(0).addClass('eq-first');

		return this;
	};

	$.fn.eqboxs = function(){
		
		//should be more than two elements
		if(this.length < 2){
			return this;
		}

		var elms = this,
			rzid = null,
			resize = function () {
				elms.equalboxes();
			};

		$(window).load(function(){
			//trigger one
			elms.equalboxes();

			clearTimeout(rzid);
			rzid = setTimeout(resize, 2000); //just in case something new loaded
		}).on('resize.eqb', function(){
			clearTimeout(rzid);
			rzid = setTimeout(resize, 200);
		});

		//trigger one
		elms.equalboxes();

		return this;
	};

})(jQuery);


//ready
(function($){

	//hack safari
	(function () {
		if($.browser.safari){
			var safarihack = document.createElement('style');
				head = document.head || document.getElementsByTagName('head')[0];

			if(safarihack){
				// add css	
				safarihack.type = 'text/css';
				var cssText = 'body { -webkit-font-smoothing: antialiased; }';
				if (safarihack.styleSheet) {
					safarihack.styleSheet.cssText = cssText;
				} else {
					safarihack.appendChild(document.createTextNode(cssText));
				}

				head.appendChild(safarihack);
			}
		}
	})();

	//fix validate.js error
	(function(){
		if(window.Browser && Browser.ie && Browser.version <= 8){
			Browser.Features.inputemail = false;
		}
	})();
	

	//document ready
	$(document).ready(function(){
		

		// add class for mainmenu when scroller
		(function(){
			var min = null,
				sid = null,
				mainnav = $('#t3-mainnav'),
				navbar = mainnav.find('.navbar:first'),
				breakpoint = navbar.length ? navbar.offset().top : 0;
			
			if(mainnav.length){
				$(window).scroll(function() {

					if(min != $(window).scrollTop() > breakpoint){
						min = !min;

						min ? mainnav.addClass('affix') : mainnav.removeClass('min-mainnav');
						
						//force reflow
						mainnav[0].offsetWidth;
						mainnav.prevAll('.hplace').remove();

						if(min){
							$('<div class="hplace clearfix"></div>').insertBefore(mainnav).css('height', mainnav.outerHeight(true));
							mainnav.addClass('min-mainnav');
						} else {
							mainnav.removeClass('affix');
						}
					}
				})
			}
		
		})();
		

 		//detect 
 		(function(){
 			Magz.rtl       = $(document.documentElement).attr('dir') == 'rtl';
 			Magz.irtl      = Magz.rtl ? -1 : 1;
 			Magz.hasTouch  = 'ontouchstart' in window && !(/hp-tablet/gi).test(navigator.appVersion);
 			Magz.isAndroid = 'ontouchstart' in window && (/android/gi).test(navigator.appVersion);
 		})();


 		//switch layout
 		(function(){
 			$('.tpl-layout-switch').on('click', 'li', function(){
 				var eswitch = $(this),
 				infinity = $('#infinity-cont');

 				if(eswitch.hasClass('active')){
 					return false;
 				}

 				infinity.removeClass('will-anim');

 				eswitch.addClass('active').siblings().removeClass('active');

 				if(eswitch.hasClass('to-grid')){
 					infinity.addClass('av-grid').removeClass('av-list');
 				} else {
 					infinity.addClass('av-list').removeClass('av-grid');
 				}

 				infinity.trigger('relayout');

 				return false;
 			})
 		})();


 		//init infinity scroll
 		(function(){
 			//extend infinityscroll
 			$.extend($.infinitescroll.prototype, {
 				_loadcallback_magz: function(box, data) {
 					var opts = this.options,
		            callback = this.options.callback, // GLOBAL OBJECT FOR CALLBACK
		            result = (opts.state.isDone) ? 'done' : (!opts.appendCallback) ? 'no-append' : 'append',
		            endstatus = data.indexOf('data-infinity-end') != -1,
		            donestatus = !endstatus && data.indexOf('data-infinity-done') != -1,
		            frag

		            if(endstatus){
		            	return this._error('end');
		            }

		            switch (result) {
		            	case 'done':
		            	this._showdonemsg();
		            	return false;

		            	case 'no-append':
		            	if (opts.dataType === 'html') {
		            		data = '<div>' + data + '</div>';
		            		data = $(data).find(opts.itemSelector);
		            	}
		            	break;

		            	case 'append':
		            	var children = box.children();
							// if it didn't return anything
							if (children.length === 0) {
								return this._error('end');
							}

							// use a documentFragment because it works when content is going into a table or UL
							frag = document.createDocumentFragment();
							while (box[0].firstChild) {
								frag.appendChild(box[0].firstChild);
							}

							this._debug('contentSelector', $(opts.contentSelector)[0]);
							$(opts.contentSelector)[0].appendChild(frag);
							// previously, we would pass in the new DOM element as context for the callback
							// however we're now using a documentfragment, which doesn't have parents or children,
							// so the context is the contentContainer guy, and we pass in an array
							// of the elements collected as the first argument.

							data = children.get();
							break;
						}

		            // loadingEnd function
		            opts.loading.finished.call($(opts.contentSelector)[0],opts);

		            // smooth scroll to ease in the new content
		            if (opts.animate) {
		            	var scrollTo = $(window).scrollTop() + $('#infscr-loading').height() + opts.extraScrollPx + 'px';
		            	$('html,body').animate({ scrollTop: scrollTo }, 800, function () { opts.state.isDuringAjax = false; });
		            }

		            if (!opts.animate) {
						// once the call is done, we can allow it again.
						opts.state.isDuringAjax = false;
					}

					callback(this, data, '');

					if (opts.prefill) {
						this._prefill();
					}

					if(donestatus){
						return this._error('end');
					}
				}
			});

 			//init infinityscrol
 			var	infinity= $('#infinity-cont'),
 				infitems= infinity.find('.items'),
	 			nextbtn = $('#infinity-next').removeClass('hidden'),
	 			paginfo = $('#page-next-link'),
	 			pathobject = {
	 				init: function(link){

	 					var pagenext = $('#page-next-link'),
	 					fromelm = false;

	 					if(!link) {
	 						fromelm = true;
	 						link = pagenext.attr('href') || '';
	 					}

	 					this.path = link;

	 					var match = this.path.match(/((page|limitstart|start)[=-])(\d+)(&*)/i);


	 					if(match){
	 						this.type = match[2].toLowerCase();
	 						this.number = parseInt(match[3]);
	 						this.limit = this.type == 'page' ? 1 : this.number;
	 						this.number = this.type == 'page' ? this.number : 1;
	 						this.init = 0;

	 						var limit = parseInt(pagenext.attr('data-limit')),
	 						init = parseInt(pagenext.attr('data-start'));

	 						if(isNaN(limit)){
	 							limit = 0;
	 						}

	 						if(isNaN(init)){
	 							init = 0;
	 						}

	 						if(fromelm && this.limit != limit && (this.type == 'start' || this.type == 'limitstart')){

	 							this.init = Math.max(0, init);
	 							this.number = 1;
	 							this.limit = limit;
	 						}

	 					} else {
	 						this.type = 'unk';
	 						this.number = 2;
	 						this.path = this.path + (this.path.indexOf('?') == -1 ? '?' : '') + 'start=';
	 					}

	 					var urlparts = this.path.split('#');
	 					if(urlparts[0].indexOf('?') == -1){
	 						urlparts[0] += '?tmpl=component';
	 					} else {
	 						urlparts[0] += '&tmpl=component';
	 					}

	 					this.path = urlparts.join('#');
	 				},

	 				join: function(){
	 					if(pathobject.type == 'unk'){
	 						return pathobject.path + pathobject.number++;
	 					} else{
	 						return pathobject.path.replace(/((page|limitstart|start)[=-])(\d+)(&*)/i, '$1' + (pathobject.init + pathobject.limit * pathobject.number++) + '$4');
	 					}
	 				}
	 			},

	 			preload = function(items){
	 				var items = items ? items : infitems;

	 				//hide
					infinity.removeClass('will-anim');
					items.addClass('anim-hide-state');
	 			},

	 			animate = function(items){
	 				var items = items ? items : infitems,
						timeBuff = 0;

					setTimeout(function(){

						//animate showin
						infinity.addClass('will-anim');

						$.each(items, function(i, item){
							setTimeout(function(){
								$(item).removeClass('anim-hide-state').addClass('anim-show-state');
							}, timeBuff += 100);
						});

					}, 0);
	 			};


 			pathobject.init();

			//init an instance
			infinity.infinitescroll({
				loading: {
					finished: undefined,
					finishedMsg: T3JSVars.finishedMsg,
					img: T3JSVars.tplUrl + '/images/ajax-load.gif',
					msg: null,
					msgText: T3JSVars.msgText,
					selector: null,
					speed: 'fast',
					start: undefined
				},
				state: {
					isDuringAjax: false,
					isInvalidPage: false,
					isDestroyed: false,
					isDone: false, // For when it goes all the way through the archive.
					isPaused: false,
					currPage: 0
				},
				debug: false,
				behavior: 'magz',
				binder: $(window), // used to cache the selector for the element that will be scrolling
				nextSelector: '#page-next-link',
				navSelector: '#page-nav',
				contentSelector: '#infinity-cont', // rename to pageFragment
				extraScrollPx: 150,
				itemSelector: '.items',
				animate: false,
				pathParse: pathobject.join,
				dataType: 'html',
				appendCallback: true,
				bufferPx: 350,
				errorCallback: function () {
					nextbtn.removeClass('active').addClass('finished').find('.inf-button').html(T3JSVars.finishedMsg);
				},
				infid: 0, //Instance ID
				pixelsFromNavToBottom: undefined,
				path: pathobject.join, // Can either be an array of URL parts (e.g. ["/page/", "/"]) or a function that accepts the page number and returns a URL
				prefill: false, // When the document is smaller than the window, load data until the document is larger or links are exhausted
				maxPage: undefined // to manually control maximum page (when maxPage is undefined, maximum page limitation is not work)
			}, function(items){

				nextbtn.removeClass('active');

				//remove no-repeat item
				items = $(items).filter(function(){
					if($(this).hasClass('no-repeat')){
						$(this).remove();

						return false;
					} else {
						return true;
					}
				});

				if(items.length){
					//update disqus if needed
					if(typeof DISQUSWIDGETS != 'undefined'){
						DISQUSWIDGETS.getCount();
					}

					//update addthis
					if(typeof addthis != 'undefined'){
						addthis.button(items.find('.addthis_button_compact').get());
					}

					infitems = infitems.add(items);

					preload(items);

					infitems.imagesLoaded()
						.always(relayout)
						.always(function(){
							animate(items);
						});

					//relayout
					relayout();
				}

				if(items.length < parseInt(paginfo.attr('data-limit') || nextbtn.attr('data-limit') || 0)){
					nextbtn.addClass('finished').find('.inf-button').html(T3JSVars.finishedMsg);
				}
				
			});

			//we remove autoload
			$(window).unbind('.infscr');

			if(nextbtn.length){
				nextbtn.find('.inf-button').on('click', function(){

					if(nextbtn.hasClass('active')){
						return false;
					}

					if(!nextbtn.hasClass('finished')){
						nextbtn.addClass('active');
						infinity.infinitescroll('retrieve');
					}

					return false;
				});
			}

			//on switch layout
			var eqmainbody = $('.article-content').find('.article-body, .t3-sidebar'),
				eqboxes = function(){
					infitems.equalboxes();
				},
				reseteqboxes = function(){
					infitems.css('min-height', '');
				},
				relayout = function(){
					
					//update mainbody
					eqmainbody.length > 1 && eqmainbody.equalboxes();

					$(window).off('resize.eqboxes orientationchange.eqboxes', eqboxes);
				
					if(infinity.hasClass('av-grid')){
						$(window).on('resize.eqboxes orientationchange.eqboxes', eqboxes);

						//trigger once
						eqboxes();
					} else {
						reseteqboxes();
					}	
				};

			if(!eqmainbody.length){
				eqmainbody = $('.t3-content, .t3-sidebar');
			}

			infinity.on('relayout', relayout)
				.imagesLoaded()
				.always(relayout)
				.always(function(){
					if(infinity.closest('.animate-me').length){
						animate();
					}
				});

			relayout();
		})();


		//fix menu
		(function(){
			var sidenav = $('.side-nav'),
				btnsidenav = $('.btn-sidenav'),
				offcanvas = $('#off-canvas-nav'),
				sid = null;

			if(sidenav.length){
				
				//remove focus
				if($.browser.msie || (/trident/i).test(window.navigator.userAgent)){
					sidenav[0].focus = null;
				}

				if(Magz.hasTouch || T3JSVars.navTrigger == 'click'){
					btnsidenav.on('click', function(){
						sidenav.modal('toggle');
						return false;
					});
				} else {

					btnsidenav.on('mouseenter', function(){
						clearTimeout(sid);

						if($.support.transition){
							sidenav.trigger($.support.transition.end);
						}

						sidenav.modal('show');

						return false;
					}).on('mouseleave', function(){

						clearTimeout(sid);
						sid = setTimeout(function(){
							
							if($.support.transition){
								sidenav.trigger($.support.transition.end);
							}

							sidenav.modal('hide');

						}, 200);

					});

					sidenav.on('mouseleave', function(){
						clearTimeout(sid);

						sid = setTimeout(function(){
							if($.support.transition){
								sidenav.trigger($.support.transition.end);
							}

							sidenav.modal('hide');
						}, 200);

					}).on('mouseenter', function(){
						clearTimeout(sid);
					});
				}

				sidenav.on('touchend.sidenav', function(e){
					e.stopPropagation();
				}).modal({
					backdrop: false,
					show: false,
				}).on('hidden', function(){
					sidenav.find('.t3-megamenu .open').removeClass('open');
				}).each(function(){
					this.show = null;
					this.hide = null;
				});

				$(document).on('click.sidenav', function(e){
					if($(e.target).closest('.side-nav').length == 0){
						sidenav.modal('hide');
					}
				});

				//merge side-nav to mainmenu on offcanvas
				if(!$('html').hasClass('no-respon')){

					if(offcanvas.length){
						sidenav.find('.t3-megamenu').clone(true, true).addClass('side-nav-ofc').appendTo(offcanvas.find('.nav-collapse'));
					} else {
						sidenav.find('.t3-megamenu').clone(true, true).addClass('side-nav-nofs').appendTo($('#t3-mainnav').find('.header-menu'));
					}
				}
			}
		})();

		//fix show/hide dropdown on touch device
		(function(){
			if(Magz.hasTouch){
			
				var sidenav = $('.side-nav'),
					subnav  = $('.head-social > ul');

				if(sidenav.length || social.length || user.length || search.length){
					$(document).on('touchend.fdropdown', function(e){
						var parents = $(e.target).parents().get();
						
						//sidenav
						if(sidenav.length && $.inArray(sidenav[0], parents) === -1){
							sidenav.modal('hide');
						}

						//lang
						if(subnav.length && $.inArray(subnav[0], parents) === -1){
							subnav.find('> li').removeClass('open');
						}
					});

					subnav.on('touchstart', '> li > a', function(e){
						subnav.find('> li').removeClass('open');
						$(this).parent().addClass('open');

						return false;
					});
				}
			}
		})();


		//equal height
		(function(){

			// special case for mainbody when show in detail article and otherwise
			var eqarticle = $('.article-content').find('.article-body, .t3-sidebar');
			if(eqarticle.length){
				eqarticle.eqboxs();
			} else {
				$('.t3-content, .t3-sidebar').eqboxs();
			}

			// spotlight 1 on home page
			$('.t3-spl-home-1').children().eqboxs();

			// media page - leading articles
			$('.infinity-leading > .leading').eqboxs();

			// all categories
			$('.categories-list-container > .category-item').eqboxs();
		})();


		// pagebreak -page
		(function(){
			$('#article-index, .article-index').addClass('dropdown pull-right')
				.find('ul').addClass('dropdown-menu').removeClass('nav-tabs nav-stacked')
				.prev().attr('data-toggle', 'dropdown').addClass('dropdown-toggle');
		})();

	});

})(jQuery);


(function($){
	
	JASliderSupport = {
		inited: false,
		sid: null,
		refresh: false,
		
		initialize: function(){
			if(window.jasliderInst && window.jasliderInst.length && !JASliderSupport.inited){

				window.jasliderInst.each(function(inst){
					inst.lastRZWidth = false;
					inst._ooptions = Object.clone(inst.options);
				});
				
				
				window.addEvent('resize', function(){
					clearTimeout(JASliderSupport.sid);
					JASliderSupport.sid = setTimeout(JASliderSupport.resize, 100);
				}).addEvent('orientationchange', function(){
					widnow.fireEvent('resize');
				});
				
				JASliderSupport.resize();
				
				JASliderSupport.inited = true;
			}
		},
		resize: function(){

			window.jasliderInst.each(function(instance){

				var ooptions = instance._ooptions,
				options = instance.options,
				vars = instance.vars,
				ratio = vars.slider.setStyle('width', '').getWidth() / ooptions.mainWidth,
				nwidth = Math.floor(ooptions.mainWidth * ratio),
				nheight = Math.floor(ooptions.mainHeight * ratio),
				ntwidth = Math.floor(ooptions.thumbWidth * ratio),
				ntheight = Math.floor(ooptions.thumbHeight * ratio);

				if(instance.lastRZWidth != nwidth){
					JASliderSupport.rzTimeout = (/iphone|ipod|ipad|android|ie|blackberry|fennec/).test(navigator.userAgent.toLowerCase()) ? 300 : 100;
					instance.lastRZWidth = nwidth;

					options.mainWidth = nwidth;
					options.mainHeight = nheight;
					options.mainWidth = nwidth;
					options.thumbWidth = ntwidth;
					options.thumbHeight = ntheight;
					options.maskWidth = Math.floor(ooptions.maskWidth * ratio);
					options.maskHeigth = Math.floor(ooptions.maskHeigth * ratio);

					vars.mainWrap.setStyles({
						'width': nwidth,
						'height': nheight
					});

					vars.mainFrame.setStyles({
						'width': nwidth,
						'height': nheight
					});

					if(options.animation == 'move'){

						vars.mainFrame.getElements('.ja-slide-item').setStyles({
							'width': nwidth,
							'height': nheight
						});

						var mainItem = vars.mainItems[0],
							mainItemSpace = options.maskStyle ? 10 : 0,
							isHorz = (options.direction == 'horizontal'),
							mainItemSize = isHorz ? (mainItem.getWidth() + mainItem.getStyle('margin-left').toInt() + mainItem.getStyle('margin-right').toInt()) : (mainItem.getHeight() + mainItem.getStyle('margin-top').toInt() + mainItem.getStyle('margin-bottom').toInt()),
							rearSize = Math.ceil(((isHorz ? vars.mainWrap.getWidth() : vars.mainWrap.getHeight()) - mainItemSize) / 2);

						vars.size = mainItemSize;
						vars.offset = (options.maskStyle ? (rearSize - mainItemSize + mainItemSpace / 2) : 0) - (options.rtl ? mainItemSpace : 0);

						vars.mainFrame.setStyle(vars.modes[1], vars.size * (vars.total + 2));
						vars.fx.set(vars.modes[0], -vars.curIdx * vars.size + vars.offset);
						
					} else {
						
						vars.mainItems.setStyles({
							'width': nwidth,
							'height': nheight
						});
					}

					instance.initMasker();
					instance.initThumbAction();
					instance.initMainCtrlButton();
					instance.initProgressBar();
				} else {
					JASliderSupport.rzTimeout *= 2;
				}
			});

			clearTimeout(JASliderSupport.sid);
			JASliderSupport.sid = setTimeout(JASliderSupport.resize, JASliderSupport.rzTimeout);
		}
	};

	$(window).load(function(){
		JASliderSupport.initialize();
	});

	$(document).ready(function() {
        $('>.nav >.dropdown .dropdown-menu', '.head-social').unbind().mouseover(function(e) {
            $(this).parents('.dropdown:first').addClass('open');
            e.stopPropagation();
        }).mousedown(function(e) {
            $(this).parents('.dropdown:first').addClass('open');
            e.stopPropagation();
        });
    });
})(jQuery);